/*********************************************************
                 ADVANCED DATA STRUCTURES
				       Assignment 1

       Created by :    Beycan Kahraman  -  040020337
*********************************************************/

#include <iostream>
#include <stdlib.h>
#include <stdio.h>

using namespace std;

#define		INITIAL		4
#define		NAME		21
#define		SURNAME		21
#define		NUMBER		11
#define		GRADE		4
#define		TOTAL		57
#define		DATABASE	"database.txt"
#define		TEMP		"tmp.txt"

// DATA STRUCTURES
typedef struct Student_Type{ // used for members of AVAIL LIST
	char	initial[INITIAL];
	char	number[NAME];
	struct	Student_Type *next;
}Student;

typedef struct Head_Type{	 // head of the AVAIL LIST
	Student *next;
}Head;

void InitHead(Head **head){
	*head = new Head;
	(*head)->next = NULL;
}

void DeleteEverything(Head **head){ // before exiting program
	Student *tmp, *del;				// deletes the whole list
	tmp = (*head)->next;
	delete (*head);
	while(tmp != NULL){
		del = tmp;
		tmp = tmp->next;
		delete del;
	}
	cout << "Everything is Successfully Deleted" << endl;
}

void AddNewStudent(Head *head, char *init, char *num){ // adding new student to AVAIL LIST
	Student *newStudent, *tmp;
	if(strlen(init) < 1 || strlen(num) < 1 || strlen(init) > INITIAL - 1 || strlen(num) > NUMBER - 1 ){
		cout << "Initial - Number Error" << endl; // Availability Control
		return;
	}
	tmp = head->next;
	if(tmp == NULL){	// First Student Been Has Added
		newStudent = new Student();
		strcpy(newStudent->number, num);
		strcpy(newStudent->initial, init);
		newStudent->next = NULL;
		head->next = newStudent;
		return;
	}else if(strcmp(tmp->number, num) < 0){ // Second Student Has Been Added
		newStudent = new Student();
		if(!newStudent){
			cout << "Not Enough Memory To Add This Student" << endl;
			return;
		}
		strcpy(newStudent->number, num);
		strcpy(newStudent->initial, init);
		newStudent->next = head->next;
		head->next = newStudent;
		return;
	}else{ // Other Students Has Been Added
		while(tmp->next != NULL && strcmp(tmp->next->number, num) > 0)
			tmp = tmp->next;
		if(tmp->next != NULL && strcmp(tmp->next->number, num) == 0){
			cout << "This Student Already Exists In The Database" << endl;
			return;
		}else{
			newStudent = new Student();
			if(!newStudent){
				cout << "Not Enough Memory To Add This Student" << endl;
				return;
			}
			strcpy(newStudent->number, num);
			strcpy(newStudent->initial, init);
			newStudent->next = tmp->next;
			tmp->next = newStudent;
			return;
		}
	}
}

void DeleteStudent(Head *head, char *num){
	Student *tmp, *next;
	tmp = head->next;
	if(tmp == NULL) // Empty AVAIL LIST
		cout << "The Database is Empty" << endl;
	else if(strcmp(tmp->number, num) == 0){ // Deletes the First Member
		next = tmp->next;
		delete tmp;
		head->next = next;
		cout << "The Student Successfully Deleted From The Database..." << endl;
	}else{ // Deletes the members
		while(tmp->next != NULL && strcmp(tmp->next->number, num) > 0)
			tmp = tmp->next;
		if(tmp->next == NULL)
			cout << "The Student Could Not Be Found In The Database" << endl;
		else if(strcmp(tmp->next->number, num) == 0){
			next = tmp->next;
			tmp->next = next->next;
			delete next;
			cout << "The Student Successfully Deleted From The Database" << endl;
		}else
			cout << "The Student Could Not Be Found In The Database..." << endl;
	}
}

void UpdateStudent(Head *head, char *num, char *ini){
	Student *tmp;
	tmp = head->next;
	if(tmp == NULL)
		cout << "The Database is Empty" << endl;
	else if(strcmp(tmp->number, num) == 0){ // Updates the First Member
		strcpy(tmp->initial, ini);
		cout << "The Student Successfully Updated..." << endl;
	}else{ // Updating Other Members
		while(tmp->next != NULL && strcmp(tmp->next->number, num) > 0)
			tmp = tmp->next;
		if(tmp->next == NULL)
			cout << "The Student Could Not Be Found In The Database" << endl;
		else if(strcmp(tmp->next->number, num) == 0){
			strcpy(tmp->next->initial, ini);
			cout << "The Student Successfully Updated..." << endl;
		}else
			cout << "The Student Could Not Be Found In The Database..." << endl;
	}
}

int SearchStudent(Head *head, char *num){
	int i = 0;
	Student *tmp;
	tmp = head->next;
	if(tmp == NULL)
		cout << "The Database is Empty" << endl;
	else if(strcmp(tmp->number, num) == 0){ // The first member Has Been Found
		if(tmp->initial[0] != ' ') 
			i += (tmp->initial[0] - '0')*100;
		if(tmp->initial[1] != ' ') 
			i += (tmp->initial[1] - '0')*10;
		i += tmp->initial[2] - '0';
		--i;
		return i;
	}else{ // Other Memebers 
		while(tmp->next != NULL && strcmp(tmp->next->number, num) > 0)
			tmp = tmp->next;
		if(tmp->next == NULL)
			cout << "The Student Could Not Be Found In The Database" << endl;
		else if(strcmp(tmp->next->number, num) == 0){
			if(tmp->next->initial[0] != ' ') 
				i += (tmp->next->initial[0] - '0')*100;
			if(tmp->next->initial[1] != ' ') 
				i += (tmp->next->initial[1] - '0')*10;
			i += tmp->next->initial[2] - '0';
			--i;
			return i;
		}else
			cout << "The Student Could Not Be Found In The Database..." << endl;
	}
	return -1;
}

void PrintAllStudents(Head *head){ // Printing All The Students
	Student *tmp;
	if(head->next == NULL){
		cout << " No Students" << endl;
		return;
	}else{
		tmp = head->next;
		cout << "      |--------------|" << endl;
		cout << "      | All Students |" << endl;
		cout << "      |--------------|" << endl;
		while(tmp->next != NULL){
			cout << "      | - " << tmp->number << " |"<< endl;
			tmp = tmp->next;
		}
		cout << "      | - " << tmp->number << " |"<< endl;
		cout << "      |--------------|" << endl;
	}
}

char *CreateString(char *in, char *tmp, int length){ // Gives ' ' (Space) character
	int i, j, len = strlen(in) + 1;					 // to non-necessary characters
	for(i=0; i<length - len; i++)
		tmp[i] = ' ';
	for(j = i; j<length - 1; j++)
		tmp[j] = in[j - i];
	tmp[j] = '\0';
	return tmp;
}

void GiveInformation(char *info){ // Gives Info About The Program Flow
	cout << "-------------------------------------------" << endl;
	cout << "  " << info << endl;
	cout << "-------------------------------------------" << endl;
}

void DrawMenu(){
	cout << endl;
	cout << "  /~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\\  " << endl;
	cout << "   |   ADD A NEW STUDENT   -->   1     |  " << endl;
	cout << "   |   DELETE A STUDENT    -->   2     |  " << endl;
	cout << "   |   UPDATE A STUDENT    -->   3     |  " << endl;
	cout << "   |   SEARCH A STUDENT    -->   4     |  " << endl;
	cout << "   |   SHOW ALL STUDENTS   -->   5     |  " << endl;
	cout << "   |   EXIT                -->   0     |  " << endl;
	cout << "   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  " << endl;
}

int main(){
	FILE	*database	= NULL, 
			*tmpFile	= NULL;
	char	*initial	= NULL,
			*name		= NULL,
			*surname	= NULL,
			*number		= NULL,
			*grade		= NULL,
			*tmpCini	= NULL,
			*tmpCnum	= NULL,
			*total		= NULL,
			c			= 0;
	int		i			= 0,
			j			= 0,
			numStudent	= 0;
	bool	menu		= true;
	initial	= new char[INITIAL];
	name	= new char[NAME];
	surname	= new char[SURNAME];
	number	= new char[NUMBER];
	grade	= new char[GRADE];
	tmpCini	= new char[INITIAL];
	tmpCnum	= new char[NAME];
	total	= new char[TOTAL];
	Head	*head;
	Student *student;

	InitHead(&head);

	// READING FROM DATABASE
	GiveInformation("Reading From Database");
	database = fopen(DATABASE, "r");
	if(database == NULL){
		database = fopen(DATABASE, "a+");
		cout << "New Database Has Created..." << endl;
	}
	while(!feof(database)){
		fgets(initial, INITIAL, database);
		if(feof(database)) break;
		fgets(total, NAME + SURNAME - 1, database);
		if(feof(database)) break;
		fgets(number, NUMBER, database);
		if(feof(database)) break;
		fgets(total, GRADE, database);
		if(strlen(initial) > 0 && strlen(number) > 0){
			numStudent++;
			AddNewStudent(head, initial, number);
		}
	}
	fclose(database);

	// MENU LOOP
	GiveInformation("Welcome to Our Menu");

	while(menu){
		DrawMenu();
		cout <<	"   Choose Option : ";
		cin >> i;
		cout << endl;
		switch(i){ // MENU OPTION HAS BEEN CHOSEN
		case 1: // Add a new Student
			cout << " Name     : ";
			scanf("%c", &c);
			i = 0;
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<NAME-1 && c != '\n'){
					name[i] = c;
					name[i+1] = '\0';
				}
				i++;
			}
			cout << " Surname  : ";
			i = 0;
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<SURNAME-1 && c != '\n'){
					surname[i] = c;
					surname[i+1] = '\0';
				}
				i++;
			}
			cout << " Number   : ";
			i = 0;
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<NUMBER-1 && c != '\n'){
					number[i] = c;
					number[i+1] = '\0';
				}
				i++;
			}
			cout << " Grade    : ";
			i = 0;
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<GRADE-1 && c != '\n'){
					grade[i] = c;
					grade[i+1] = '\0';
				}
				i++;
			}
			database = fopen(DATABASE, "a+");
			if(database != NULL){
				numStudent++;
				if(numStudent/100 > 0)
					initial[0] = numStudent/100 + '0';
				else
					initial[0] = ' ';
				if((numStudent/10)%10 > 0)
					initial[1] = (numStudent/10)%10 + '0';
				else
					initial[1] = ' ';
				initial[2] = numStudent%10 + '0';
				initial[3] = '\0';
				fprintf(database, "%s%s", CreateString(initial, tmpCini, INITIAL), CreateString(name, tmpCnum, NAME));
				fprintf(database, "%s", CreateString(surname, tmpCnum, NAME));
				fprintf(database, "%s%s", CreateString(number, tmpCnum, NUMBER), CreateString(grade, tmpCini, GRADE));
				fclose(database);
				cout << endl;
				AddNewStudent(head, CreateString(initial, tmpCini, INITIAL), CreateString(number, tmpCnum, NUMBER));
			}
			break;
		case 2: // Delete a Student
			cout << "Number of The Student to be Deleted : ";
			i = 0;
			scanf("%c", &c);
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<NUMBER-1 && c != '\n'){
					number[i] = c;
					number[i+1] = '\0';
				}
				i++;
			}
			DeleteStudent(head, CreateString(number, tmpCnum, NUMBER));
			break;
		case 3: // Update a Student
			cout << "Number of The Student to be Updated : ";
			i = 0;
			scanf("%c", &c);
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<NUMBER-1 && c != '\n'){
					number[i] = c;
					number[i+1] = '\0';
				}
				i++;
			}
			database = fopen(DATABASE, "a+");
			if(database != NULL){
				cout << " Name     : ";
				i = 0;
				c = '*';
				while(c != '\n'){
					scanf("%c", &c);
					if(i<NAME-1 && c != '\n'){
						name[i] = c;
						name[i+1] = '\0';
					}
					i++;
				}
				cout << " Surname  : ";
				i = 0;
				c = '*';
				while(c != '\n'){
					scanf("%c", &c);
					if(i<SURNAME-1 && c != '\n'){
						surname[i] = c;
						surname[i+1] = '\0';
					}
					i++;
				}
				cout << " Grade    : ";
				i = 0;
				c = '*';
				while(c != '\n'){
					scanf("%c", &c);
					if(i<GRADE-1 && c != '\n'){
						grade[i] = c;
						grade[i+1] = '\0';
					}
					i++;
				}
				numStudent++;
				if(numStudent/100 > 0)
					initial[0] = numStudent/100 + '0';
				else
					initial[0] = ' ';
				if((numStudent/10)%10 > 0)
					initial[1] = (numStudent/10)%10 + '0';
				else
					initial[1] = ' ';
				initial[2] = numStudent%10 + '0';
				initial[3] = '\0';
				fprintf(database, "%s%s", CreateString(initial, tmpCini, INITIAL), CreateString(name, tmpCnum, NAME));
				fprintf(database, "%s", CreateString(surname, tmpCnum, NAME));
				fprintf(database, "%s%s", CreateString(number, tmpCnum, NUMBER), CreateString(grade, tmpCini, GRADE));
				fclose(database);
				UpdateStudent(head, CreateString(number, tmpCnum, NUMBER), CreateString(initial, tmpCini, INITIAL));
				cout << endl;
			}
			break;
		case 4: // Search a Student
			cout << "Number of The Student to be Searched : ";
			i = 0;
			scanf("%c", &c);
			c = '*';
			while(c != '\n'){
				scanf("%c", &c);
				if(i<NUMBER-1 && c != '\n'){
					number[i] = c;
					number[i+1] = '\0';
				}
				i++;
			}
			database = fopen(DATABASE, "r");
			if(database != NULL){
				i = SearchStudent(head, CreateString(number, tmpCnum, NUMBER));
				if(i < 0)
					break;
				fseek(database, (TOTAL - 1)*i, 0);
				fgets(initial,	INITIAL,	database);
				fgets(name,		NAME,		database);
				fgets(surname,	SURNAME,	database);
				fgets(number,	NUMBER,		database);
				fgets(grade,	GRADE,		database);
				fclose(database);
				cout << "*************************************************************" << endl;
				cout << "                  Name              Surname     Number  Grade" << endl;
				cout << " ---------------------  -------------------  ---------  -----" << endl;
				cout << "  " << name << " " << surname << " " << number << "    " << grade << endl;
				cout << "*************************************************************" << endl;
			}else{
				cout << "Database Could Not Be Found" << endl;
			}
			break;
		case 5: // Printing All The Students
			PrintAllStudents(head);
			break;
		default: // Exiting The Menu
			menu = false;
			break;
		}
	}

	// UPDATING THE DATABASE
	GiveInformation("Updating The Database");
	// Creating The Temp DAtabase
	database = fopen(DATABASE, "r");
	if(database != NULL){
		tmpFile = fopen(TEMP, "w");
		numStudent = 0;
		student = head->next;
		while(student != NULL){
			fseek(database, 0, 0);
			i = 0;
			if(student->initial[0] != ' ') 
				i += (student->initial[0] - '0')*100;
			if(student->initial[1] != ' ') 
				i += (student->initial[1] - '0')*10;
			i += student->initial[2] - '0';
			i--;
			fseek(database, (TOTAL - 1)*i, 0);
			fgets(initial, INITIAL, database);
			if(feof(database)){
				cout << "The Database File Has Been Corrupted..." << endl;
				break;
			}
			fgets(total, TOTAL - INITIAL + 1, database);
			numStudent++;
			if(numStudent < 10)
				fprintf(tmpFile, "  ");
			else if(numStudent < 100)
				fprintf(tmpFile, " ");
			fprintf(tmpFile, "%d%s", numStudent, total);
			student = student->next;
		}
		cout << "Temporary Database Has Been Created Successfully" << endl;
		fclose(tmpFile);
		fclose(database);
	}else
		cout << "Database Could Not Be Found" << endl;

	// Copying Database From Temp
	tmpFile = fopen(TEMP, "r");
	if(tmpFile != NULL){
		database = fopen(DATABASE, "w");
		fscanf(tmpFile, "%c", &c);
		while(!feof(tmpFile)){
			fprintf(database, "%c", c);
			fscanf(tmpFile, "%c", &c);
		}
		cout << "Database Has Been Updated Successfully" << endl;
		fclose(database);
		fclose(tmpFile);
	}else
		cout << "Could Not Save Temporary Database..." << endl;

	// Removing Unnecessary Files & Members
	unlink(TEMP);
	DeleteEverything(&head);
	delete [] initial;
	delete [] name;
	delete [] surname;
	delete [] number;
	delete [] grade;
	delete [] tmpCini;
	delete [] tmpCnum;
	delete [] total;
	return 1;
}
